// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRVSAT_DHCP_ARP
#define NPRVSAT_DHCP_ARP

void reset_DHCP_table();

int DHCP_ARP_print_entries(void);

void DHCP_server(unsigned char* RX_data, int size_UDP);

void ARP_proxy(unsigned char* ARP_req_packet, int size);

void ARP_client_request(uint32_t IP);

//void ARP_client_answer_treatment(unsigned char* ARP_RX_packet, int size);

void ARP_RX_packet_treatment(unsigned char* ARP_RX_packet, int size);

void DHCP_ARP_periodic_free_table();

int lookfor_MAC_from_IP(unsigned char* MAC_out, uint32_t IP_addr);

#endif
