// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRVSAT_Eth_IPv4
#define NPRVSAT_Eth_IPv4

uint32_t IP_char2int(unsigned char* IP_char);

void IP_int2char(uint32_t IP_int, unsigned char* IP_char);

void IP_int2txt(uint32_t IP_int, char* IP_char);

void NPRV_IPv4_init_TX_struct(void);

int NPRV_IPv4_push_TX_pckt(unsigned char* in_pckt, int size, unsigned int dest_ID);

int NPRV_IPv4_get_TX_filling(void);

int NPRV_IPv4_TX_data_available(void);

int NPRV_IPv4_get_TXr_frame(unsigned char* tx_frame, int avail_size);

void NPR_IPv4_init_RX_reconstr(void);

void NPRV_IPv4_rFrame_interpret(unsigned char* data_RX, int rframe_size, uint32_t sync_time);

int Eth_RX_dequeue(void);

void flush_temp_Eth_buffer(uint32_t loc_IP);

void IPv4_RX_dequeue(unsigned char* data, int size, int is_unicast);

void IPv4_to_radio(unsigned char* data, int size);

void UDP_to_LAN(unsigned char* data_UDP, int size_UDP, uint32_t dest_IP, unsigned char* dest_MAC, unsigned int source_port, unsigned int dest_port);

//void IPv4_to_LAN(unsigned char* raw_Eth, int raw_size);
void IPv4_to_LAN(unsigned char* RX_eth_frame, int RX_size, unsigned int TXID, unsigned int RXID);

void ICMP_reply(unsigned char* raw_IP_pckt, int raw_size);

unsigned int lookfor_client_ID_from_IP(uint32_t IP_addr);

#endif
