#include "pch.h"
#include "NPRV_glob_variables.h"
#ifdef NPRV_linux
#include "Linux_tuntap_if.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <net/if.h>
#include <linux/if.h>
#include <linux/if_tun.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <SFML/System.hpp>
#include <unistd.h>/*pour sleep*/

static int TUN_TAP_status = 0;//!!! A completer

int tun_alloc(char *dev, int flags) {

  struct ifreq ifr;
  int fd, err;
  //char *clonedev = "/dev/net/tun";
  char clonedev[30];
  strcpy(clonedev,"/dev/net/tun");

  /* Arguments taken by the function:
   *
   * char *dev: the name of an interface (or '\0'). MUST have enough
   *   space to hold the interface name if '\0' is passed
   * int flags: interface flags (eg, IFF_TUN etc.)
   */

   /* open the clone device */
   if( (fd = open(clonedev, O_RDWR)) < 0 ) {
     return fd;
   }

   /* preparation of the struct ifr, of type "struct ifreq" */
   memset(&ifr, 0, sizeof(ifr));

   ifr.ifr_flags = flags;   /* IFF_TUN or IFF_TAP, plus maybe IFF_NO_PI */

   if (*dev) {
     /* if a device name was specified, put it in the structure; otherwise,
      * the kernel will try to allocate the "next" device of the
      * specified type */
     strncpy(ifr.ifr_name, dev, IFNAMSIZ);
   }

   /* try to create the device */
   if( (err = ioctl(fd, TUNSETIFF, (void *) &ifr)) < 0 ) {
     close(fd);
     return err;
   }

  /* if the operation was successful, write back the name of the
   * interface to the variable "dev", so the caller can know
   * it. Note that the caller MUST reserve space in *dev (see calling
   * code below) */
  strcpy(dev, ifr.ifr_name);

  /* this is the special file descriptor that the caller will use to talk
   * with the virtual interface */
  return fd;
}

int tun_fd;

//int test_tuntap_linux (void) {
int init_tuntap (void) {
	//int tun_fd;
	char tun_name[IFNAMSIZ];
	int nread;
	int i;
	int count = 0;
	int flags;
	unsigned char buffer[2000] = { 0 };
	unsigned char ctemp;
	
	//sf::RenderWindow window(sf::VideoMode(200, 200), "SFML works!");
	
	printf("hello world 3\r\n");
	strcpy(tun_name, "tap_01");
	
	//test_annex();
	
	//tun_fd = tun_alloc(tun_name, IFF_TUN | IFF_NO_PI);  /* tun interface */
	//tun_fd = tun_alloc(tun_name, IFF_TAP | IFF_NO_PI);  /* tun interface */
	tun_fd = tun_alloc(G_NPRV_tuntap_name, IFF_TAP | IFF_NO_PI);  /* tun interface */
	
	//fcntl(tun_fd, F_SETFL, O_NONBLOCK);
	flags = fcntl(tun_fd, F_GETFL, 0);
	fcntl(tun_fd, F_SETFL, flags | O_NONBLOCK);
	
	if(tun_fd < 0){
		printf("ERR Allocating interface\r\n");
		exit(1);
	}
	printf("ready\r\n");

	return 0;
}

int connect_tuntap(void) {
	unsigned char RX_data[5600] = { 0 };
	int RX_size = 0;
	TUN_TAP_status = 1;
	do {//flush IP data
		RX_size = tuntap_recv_packet(RX_data);
	} while (RX_size > 0);
	return 1;
}

int disconnect_tuntap(void) {
	TUN_TAP_status = 0;
	return 1;
}

size_t tuntap_recv_packet(unsigned char* buffer) {
	int nread = 0;
	if (TUN_TAP_status == 1) {
		nread = read(tun_fd, buffer, 2000);
		if (nread > 0) {
			//printf("tuntap size:%i\r\n", nread);
		}
	}
	return nread;
}

int tuntap_send_packet(unsigned char* buffer, size_t len) {
	//printf("tuntap attempt to write %i\r\n", len);
	if (TUN_TAP_status == 1) {
		write(tun_fd, buffer, len);
	}
	return 1; 
}

#endif