// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_HMI
#define NPRV_HMI

void NPRV_save_stat_TX(int modulation);

void NPRV_RX_discovery_state_save(uint32_t rand_RX);

void NPRV_BER_stat_save(int errors, int words, int modul_type);

void NPRV_HMI_save_BER_frames(int modul, int BER_header, int BER_DataField, int byte_size, unsigned int TX_ID);

void NPRV_get_BER_stat(float* BER_answer_BPSK, float* BER_answer_QPSK);

void NPRV_FrameErr_stat_save(int errors, int modulation, unsigned int TX_ID);

//void NPRV_HMI_store_amp_RX_frame(uint32_t TX_ID, float amplitude);
void NPRV_HMI_store_amp_RX_frame(uint32_t TX_ID, float amplitude, int channel);

int NPRV_HMI_print_radio_stats(void);

//void NPRV_get_BER_stat(float* err_2FSK, float* err_4FSK);
void NPRV_get_FrameErr_stat(float* err_2FSK, float* err_4FSK);

int NPRV_HMI_print_who(void);

#endif