// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_SDR_IF
#define NPRV_SDR_IF

int NPRV_SDR_open(void);

void NPRV_SDR_close(void);

void NPRV_SDR_init_gain(int set_gain_txrx);

int NPRV_SDR_configure(void);

void NPRV_SDR_re_configure(void);

int NPRV_SDR_start_stream(void);

void NPRV_SDR_stop_stream(void);

int NPRV_SDR_read_stream(void* buffer_out, size_t length);

int NPRV_SDR_write_stream(void* buffer_in, size_t length);

void NPRV_SDR_calib_IQ(void);

void NPRV_store_ampl_RX_frame(unsigned int TX_ID, int channel, float amplitude);

void NPRV_SDR_Start_stop_recording(void);

void NPRV_HMI_new_TXT_message(void);

int NPRV_SDR_main_loop(void);

//void NPRV_SDR_autoGain_RX(short int* IQ_sampl_in, size_t length);

void NPR_SDR_setautogainRX(void);
void NPRV_SDR_autoGain_RX();

void NPR_SDR_setautogainTX(void);

void NPRV_SDR_TX_gain_capability_change(int previous_capa, int new_capa, int apply_immediately);

void NPRV_SDR_store_TX_event(void);

void NPRV_SDR_store_RX_ME_event(void);

void NPRV_SDR_client_autoGain_TX_periodic_call(void);

//void NPRV_SDR_autoGain_TX();

void NPRV_print_gain_RX(void);

int NPRV_TX_test_seq(int channel);

void NPRV_TX_test_periodic_call(void);

void NPRV_SDR_set_freq_offset_conf(float freq_offset_TX_conf);

void NPRV_collect_freq_offset_RX(int channel, float freq_in);

void NPRV_collect_freq_offset_TX(int channel, float freq_in);

void NPRV_collect_freq_offset_TX_my_discovery(int channel, float freq_in, uint32_t rand_nb_rx);

void NPRV_print_freq_offset(void);

void NPRV_periodic_freq_retune(void);

/*
void NPRV_SDR_init_freq_offset_NVRAM(int16_t offset_freqRX_conf, int16_t offset_freqTX_conf, int16_t offset_freqRX_tuned, int16_t offset_freqTX_tuned);

void NPRV_SDR_set_freq_offset_userconf(float offset_freqRX_conf, float offset_freqTX_conf);

void NPRV_SDR_get_freq_offset_for_NVRAM(int16_t* offset_freqRX_conf, int16_t* offset_freqTX_conf, int16_t* offset_freqRX_tuned, int16_t* offset_freqTX_tuned);
*/
#endif
