// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_TDMA
#define NPRV_TDMA

void TDMA_init_all(int file_debug);

void NPRV_TDMA_hub_alloc(void);

int NPRV_check_TDMA_hub_content(void);

int NPRV_HubGetTDMAallocframe(unsigned char* data, int avail_size, int is_first, unsigned char current_uslot);

void NPRV_increase_master_TDMA_Frame(void);

void NPRV_client_interpret_TDMA_alloc(unsigned char* data, int size);

void TDMA_TX_burst_event_inform(unsigned char channel, unsigned char slot_counter, uint32_t TX_time);

void TDMA_measure_my_TA(unsigned char announced_chan, unsigned char announced_slot_count, uint32_t RX_time);

void TDMA_measure_my_TA_discovery(unsigned char announced_chan, unsigned char announced_burst_count, uint32_t loc_RX_time_sync, uint32_t rand_RX);

//void TDMA_measure_Master_timings(unsigned char TDMA_byte, int top_synchro, unsigned int TX_ID, uint32_t timing);
void TDMA_measure_Master_timings(unsigned char TDMA_byte, int top_synchro, unsigned int TX_ID, uint32_t timing, unsigned char channel);

void TDMA_store_client_need(unsigned char TDMA_byte, unsigned int TX_ID);

uint32_t TDMA_get_T_future_slot(unsigned char slot_nb);

unsigned char NPRV_elaborate_client_TDMA_byte(void);

#endif