// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_COD_DECOD
#define NPRV_COD_DECOD

void NPRV_test_FEC(void);

//void NPRV_rx_symb_decode(unsigned int loc_symbol, float RSSI, unsigned long int RX_time, int channel);
int NPRV_rx_symb_decode(
	unsigned int loc_symbol, uint32_t RX_time, float amplitude, float freq_offset, int channel);

void NPRV_FEC_stat_display(void);

int NPRV_inner_FEC_decode(unsigned char* symbols_in, int size_symb_in, int modul_typ,
	unsigned char* data_decoded, int* size_out);

//void NPRV_rx_RT_header_interp(unsigned char* data, int* is_2_4_FSK, int* length);
// --> migrated to L1 L2 radio


int NPRV_tx_code_frame_single(
	unsigned char* raw_frame, int size_in, unsigned char* symbols_out, int M2_4_FSK, int size_preambl);

//float NPRV_mod_get_new_symbol(float* mod_ampl, float* mod_ampl_var, int channel);
void NPRV_coder_init(void);

unsigned char NPRV_mod_get_new_symbol(float* mod_ampl, float* mod_ampl_var, int channel);

int NPRV_tx_plan_new_burst(int channel, uint32_t T_begin, uint32_t slot_duration, unsigned char uslot_counter);

uint32_t NPRV_check_next_prog_burst2(int channel, uint32_t* duration, unsigned char* uslot_counter);

uint32_t NPRV_check_next_prog_burst(int channel, uint32_t* duration, unsigned char* uslot_counter);

#endif