// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_CONFIG
#define NPRV_CONFIG

void NPRV_init_config(void);

void NPRV_config_save_TX_test_RX_freq(float freq_loc);

void NPRV_read_config_from_file(int all_data);

void NPRV_read_IP_hub_config(void);

void NPRV_TDMA_hub_config(
	int* big_upl_thrsh,
	int* big_upl_age_thrsh,
	int* slow_client_age_offset,
	int* slow_perdiod_denom,
	int* discovery_slot_size,
	int* discovery_slot_period,
	int* hub_dedicated_slots
);

void NPRV_init_client_config(void);

void NPRV_init_Hub_config(void);

void NPRV_display_config(void);

void NPRV_check_config_update(int SDR_inhibit);

#endif