// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_DISPLAY
#define NPRV_DISPLAY

void NPRV_display_set_windows_pos(uint16_t posX_constel, uint16_t posY_constel, uint16_t posX_eye, uint16_t posY_eye);

void NPRV_display_config(int activ_constellation_loc, int activ_eye_loc);

void NPRV_init_display(void);

void NPRV_dipl_close_all_windows(void);

//void NPRV_display_IQ(short int* raw_IQ);
void NPRV_display_IQ(float* raw_IQ, char* color_loc);

void NPRV_display_eye(float* data_I, float* data_Q, float* data_BPSK);

#endif