// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_MOD_DEMOD
#define NPRV_MOD_DEMOD

void NPRV_demod_modif_param_live(
	float costas_QP_kP_loc,
	float costas_QP_kI_loc,
	float costas_BP_kP_loc,
	float costas_BP_kI_loc,
	float Clock_recov_BPSK_kP,
	float Clock_recov_QPSK_kP,
	float ampl_ratio_freq_comp,
	float PSK_freq_comp_gain,
	float demod_ampl_threshold,
	int costas_on_symb, 
	float QPSKins_costas_kI
);

void NPRV_demod_switch_PSK_ModulTyp(int new_ModulTyp, int post_sync_word, int chan);

float NPRV_demod_count_MER_test(void);

void NPRV_demod_set_channels(void);

void NPRV_demod_freq_offset_init(int channel);
//void NPRV_demod_freq_offset_select_chan(int channel_loc);
//void NPRV_demod_freq_offset(short int* data_in_I, short int* data_in_Q, float* data_out_I, float* data_out_Q);
//void NPRV_demod_freq_offset(short int* data_in_I, short int* data_in_Q, float* data_out_I, float* data_out_Q, int chn);
//void NPRV_demod_freq_offset(short int data_in_I, short int data_in_Q, float* data_out_I, float* data_out_Q, int chn);
void NPRV_demod_freq_offset(float data_in_I, float data_in_Q, float* data_out_I, float* data_out_Q, int chn);

int print_demod_data(void);

//void NPRV_demod_butterw_filter_select_chan(int channel_loc);
//void NPRV_demod_butterw_filter(float* data_in_I, float* data_in_Q, float* data_out_I, float* data_out_Q);

void NPRV_demod_BFiltTest_init(double FCoup);

void NPRV_init_butterworth_filter(void);

//void NPRV_demod_butterw_filter(float* data_in_I, float* data_in_Q, float* data_out_I, float* data_out_Q, int chan);

//void NPRV_freq_extract_select_chan(int channel_loc);
//float NPRV_freq_extract(float sample_I, float sample_Q, float* amplitude);
float NPRV_freq_extract(float sample_I, float sample_Q, float* amplitude, int chan);

//void NPRV_symbol_extract_select_chan(int channel_loc);
//void NPRV_symbol_extract(float freq_in, float amplitude_in, float* data_disp);
void NPRV_symbol_extract_FSK(float freq_in, float amplitude_in, float* data_disp, int chn);

//void NPRV_symbol_extract2_select_chan(int channel_loc);
//void NPRV_symbol_extract2(float freq_in, float amplitude_in);
void NPRV_symbol_extract2(float freq_in, float amplitude_in, int chn);

//void NPRV_freq_offset_comp(float freq_offset_in, float amplitude_in);
void NPRV_freq_offset_comp(float freq_offset_in, float amplitude_in, int chan);

void NPRV_mod_init(void);
void NPRV_demod_indiv(short int* IQ_samples_in, short int* IQ_samples_out, float* data_for_display, size_t length, int loc_channel);

void NPRV_demod_total(short int* IQ_samples_in, short int* IQ_samples_out, float* data_for_display, size_t length);

int NPRV_mod_total(short int* IQ_samples_out, size_t length);

int NPRV_mod_total_2(short int* IQ_samples_out, size_t length);

//float NPRV_mod_get_new_symbol(float* mod_ampl, float* mod_ampl_var, int channel); 

//int NPRV_tx_plan_new_frame(unsigned char* raw_frame, int size_in, int FSK_2_4, int channel, unsigned long int timing);

//int NPRV_tx_plan_new_burst(int channel, unsigned long int timing);

//void test_costas(void);

#endif