// This file is part of "NPR-VSAT SDR Modem" software
// (New-Packet-Radio, via VSAT, software modem for PC with duplex SDR)
// (A virtual/SDR data IPv4 modem for amateur radio geostationary satellite, 
// Mostly designed for Hamnet connectivity over QO-100)
// Copyright (c) 2020-2023 Guillaume F. F4HDK (amateur radio callsign)
// contact e-mail : f4hdk [at] free [dot] fr
// 
// "NPR-VSAT Software Modem" is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// "NPR-VSAT Software Modem" is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with "NPR-VSAT Software Modem".  If not, see <http://www.gnu.org/licenses/>

#ifndef NPRV_SIGNALING
#define NPRV_SIGNALING

//int NPRV_get_signal_hub_TX_RFChan(unsigned char* content);

//void NPRV_signal_hub_update_conf(void);
void NPRV_signal_hub_RFChan_update(void);
void NPRV_signal_hub_TimingConf_update(void);

void NPRV_signal_prioritize_TX_ConReq(void);

int NPRV_signaling_TX_data_available(void);

int NPRV_signaling_TX_get_frame(unsigned char* tx_frame, int avail_size);

uint32_t NPRV_signaling_RX_frame_interpret(unsigned char* raw_frame, int size);

void NPRV_signaling_periodic_call(void);

void NPRV_signaling_print_connection_status(void);

#endif