#include "pch.h"
#include "NPRV_glob_variables.h"
#ifdef NPRV_windows
#include "Win_tuntap_if.h"
#include <iostream>
#include<functional>
#include<windows.h>
#include<winioctl.h>
#include <string.h>
#include "windows_registry.h"
#pragma warning(disable: 4996)


#define TAP_WINDOWS_CONTROL_CODE(x) \
	CTL_CODE (FILE_DEVICE_UNKNOWN, x, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define TAP_WINDOWS_IOCTL_GET_MAC TAP_WINDOWS_CONTROL_CODE(1)
#define TAP_WINDOWS_IOCTL_GET_MTU TAP_WINDOWS_CONTROL_CODE(3)
#define TAP_WINDOWS_IOCTL_GET_INFO TAP_WINDOWS_CONTROL_CODE(4)
#define TAP_WINDOWS_IOCTL_SET_MEDIA_STATUS TAP_WINDOWS_CONTROL_CODE(6)
#define TAP_WINDOWS_IOCTL_CONFIG_TUN TAP_WINDOWS_CONTROL_CODE(10)

std::string adapter_GUID = "aa";
HANDLE fd;

static int TUN_TAP_status = 0;//!!! A complter

//dbuf recv_buf;
//dbuf send_buf;
unsigned char recv_buf[20000] = { 0 };
#define recv_buf_size 20000
unsigned char send_buf[20000] = { 0 };
#define send_buf_size 20000
OVERLAPPED recv_overlapped;
OVERLAPPED send_overlapped;
HANDLE recv_event;
HANDLE recv_wait;
DWORD received_sync;
bool sent_sync;
std::function<void()> read_ready_cb;

void tuntap_do_read() {
	do {
		memset(&recv_overlapped, 0, sizeof(recv_overlapped));
		recv_overlapped.hEvent = recv_event;
		// if ReadFile completes synchronously then received_sync is bytes read, otherwise operation is async and received_sync is zero
		if (ReadFile(fd, recv_buf, recv_buf_size, &received_sync, &recv_overlapped) == FALSE) {
			if (GetLastError() != ERROR_IO_PENDING) {
				//throw check_err_exception("tuntap::do_read::ReadFile");
				printf("ERR tuntap::do_read::ReadFile\r\n");
			}
			//dout() << "tuntap::do_read proceeding async";
			//printf("tuntap::do_read proceeding async\r\n");
			received_sync = 0; // operation is proceeding asynchronously
			break;
		}
		//dout() << "tuntap::do_read got sync bytes " << received_sync;
		//printf("tuntap_do_read got sync bytes %i \r\n", received_sync);
		if (received_sync != 0)
			break;
		// this should never really happen, if it does (especially repeatedly) then it may be necessary to go to a blocking thread-based implementation for windows
		//wout() << "Got synchronous tuntap read of zero bytes, retrying";
		//printf("Got synchronous tuntap read of zero bytes, retrying\r\n");
		tuntap_do_read();
	} while (true);
}

void tuntap_do_write(size_t len) {
	memset(&send_overlapped, 0, sizeof(send_overlapped));
	DWORD bytes_ignored;
	sent_sync = WriteFile(fd, send_buf, len, &bytes_ignored, &send_overlapped);
	if (!sent_sync && GetLastError() != ERROR_IO_PENDING) {
		sent_sync = true; // (an async operation is not pending)
		//throw check_err_exception("tuntap::do_write::WriteFile");
		printf("ERR tuntap::do_write::WriteFile\r\n");
	}
}

//void tuntap_set_read_ready_cb(const std::function<void()> &cb, size_t default_bufsize)
//{
//	read_ready_cb = cb;
	// do the first async read here to make data available right away and simplify the code in recv_packet a little
//	recv_buf = dbuf(default_bufsize);
//	tuntap_do_read();
//}

//VOID CALLBACK tuntap_read_event_cb(PVOID param, BOOLEAN /*used for timers, ignored*/)
//{
//	tuntap* tt = reinterpret_cast<tuntap*>(param);
//	tt->read_ready_cb();
//}

void tuntap_get_human_name(const char* guid_loc, char* name_out) {
	char ConnectionKey[500] = "SYSTEM\\CurrentControlSet\\Control\\Network\\{4D36E972-E325-11CE-BFC1-08002BE10318}";
	strcat(ConnectionKey, "\\");
	//char loc_name[200];
	std::string loc_name = "aa";
	strcat(ConnectionKey, guid_loc);
	strcat(ConnectionKey, "\\Connection");
	printf("key name:%s\r\n", ConnectionKey);
	registry_key regConnection(HKEY_LOCAL_MACHINE, ConnectionKey, KEY_READ);
	printf("opened\r\n");

	try {
		regConnection.values().get_value_string("Name");
	}
	catch (const registry_exception &re) {
		//dout() << "Failed to access registry subkey: " << re;
		printf("error 1 fail to access subkey %s\r\n", re);
	}

	//loc_name = regConnection.values().get_value_string("Name");
	printf("name:%s\r\n");
}

int init_tuntap(void) {
	sent_sync = true; // no async send in progress
	received_sync = 0;
	memset(&recv_overlapped, 0, sizeof(OVERLAPPED));
	memset(&send_overlapped, 0, sizeof(OVERLAPPED));
	recv_event = CreateEvent(nullptr, FALSE, FALSE, nullptr);
	if (recv_event == INVALID_HANDLE_VALUE)
		//throw check_err_exception("CreateEvent failed for tuntap recv_event");
		printf("ERR CreateEvent failed for tuntap recv_event\r\n");
	recv_overlapped.hEvent = recv_event;

	//read_ready_cb = []() { eout() << "BUG: tuntap read ready callback called but not set"; };
	//if (RegisterWaitForSingleObject(&recv_wait, recv_event, &tuntap_read_event_cb, this, INFINITE, WT_EXECUTEINWAITTHREAD) == FALSE)
		//throw check_err_exception("RegisterWaitForSingleObject on tuntap read event");
	//	printf("ERR RegisterWaitForSingleObject on tuntap read event\r\n");

	std::string toto;
	int interf_nb = 0;
	try {
		// open registry key for all network adapters
		registry_key adapters(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Class\\{4D36E972-E325-11CE-BFC1-08002BE10318}", KEY_READ);
		//adapters.values().get_value_string("Name");
		for (auto &it : adapters.subkeys()) {
			//printf("test %i\r\n", it);
			try {
				//printf("test a\r\n");
				registry_key adapter = it.get(KEY_READ);
				printf("test %i\r\n", it);
				// TODO: change ComponentId from "tap0901" to some other string to remove possible namespace collision with OpenVPN (this has to occur in the driver too)
				if (adapter.values().get_value_string("ComponentId") == "tap0901") {
					adapter_GUID = adapter.values().get_value_string("NetCfgInstanceId");
					//toto = adapter.values().get_value_string("NetCfgInstanceId");
					printf("found!! %s\r\n", adapter_GUID);
					interf_nb++;
				}
			}
			catch (const registry_exception &re) {
				printf("error 1 fail to access subkey\r\n");
			}

		}
	}
	catch (const registry_exception &re) {
		printf("error 2\r\n");
		throw;
	}
	printf("found %i interfaces\r\n", interf_nb);

	char adapter_guid_char[500];
	char name_out[500];
	//strcat(adapter_guid_char, adapter_GUID.c_str());
	strcpy(adapter_guid_char, adapter_GUID.c_str());
	//printf("avant get_name\r\n");
	//tuntap_get_human_name(adapter_guid_char, name_out);
	//printf("apres get_name\r\n");

	char ta_filename_ch[1024] = "\\\\.\\Global\\";
	strcat(ta_filename_ch, adapter_GUID.c_str());
	strcat(ta_filename_ch, ".tap");
	printf("handle: %s\r\n", ta_filename_ch);
	wchar_t wString[1024];
	MultiByteToWideChar(CP_ACP, 0, ta_filename_ch, -1, wString, 4096);
	fd = CreateFile(wString, GENERIC_READ | GENERIC_WRITE, 0/*no shared access*/, nullptr, OPEN_EXISTING, FILE_ATTRIBUTE_SYSTEM | FILE_FLAG_OVERLAPPED, nullptr);
	if (fd == INVALID_HANDLE_VALUE) {
		printf("erreur ouverture fichier");
	}
	/*
	DWORD rsize;
	ULONG connected = TRUE;
	if (DeviceIoControl(fd, TAP_WINDOWS_IOCTL_SET_MEDIA_STATUS, &connected, sizeof(connected), &connected, sizeof(connected), &rsize, nullptr) == FALSE)
		printf("error fail to set TAP to connected\r\n");
	ULONG ifmtu;
	if (DeviceIoControl(fd, TAP_WINDOWS_IOCTL_GET_MTU, &ifmtu, sizeof(ifmtu), &ifmtu, sizeof(ifmtu), &rsize, nullptr)) {
		printf("MTU = %i\r\n", ifmtu);
	}
	else {
		printf("Failed to get Tap-Windows MTU, assuming default\r\n");
	}
	*/
}

int connect_tuntap(void) {
	unsigned char RX_data[5600] = { 0 };
	int RX_size;
	DWORD rsize;
	ULONG connected = TRUE;
	ULONG ifmtu;
	if (TUN_TAP_status == 0) {
		if (DeviceIoControl(fd, TAP_WINDOWS_IOCTL_SET_MEDIA_STATUS, &connected, sizeof(connected), &connected, sizeof(connected), &rsize, nullptr) == FALSE)
			printf("error fail to set TAP to connected\r\n");

		if (DeviceIoControl(fd, TAP_WINDOWS_IOCTL_GET_MTU, &ifmtu, sizeof(ifmtu), &ifmtu, sizeof(ifmtu), &rsize, nullptr)) {
			//printf("MTU = %i\r\n", ifmtu);
		}
		else {
			printf("Failed to get Tap-Windows MTU, assuming default\r\n");
		}
		do {//flush IP data
			RX_size = tuntap_recv_packet(RX_data);
		} while (RX_size > 0);
		TUN_TAP_status = 1;
	}
	return 1;
}

int disconnect_tuntap(void) {
	DWORD rsize;
	ULONG connected = FALSE;
	if (DeviceIoControl(fd, TAP_WINDOWS_IOCTL_SET_MEDIA_STATUS, &connected, sizeof(connected), &connected, sizeof(connected), &rsize, nullptr) == FALSE)
		printf("error fail to set TAP to DISconnected\r\n");
	printf("TUNTAP DISCONNECTED\r\n");
	TUN_TAP_status = 0;
	return 1;
}

//size_t tuntap_recv_packet(dbuf &buf)
size_t tuntap_recv_packet(unsigned char* buf) {
	// interesting possible trouble: if async read fails then obviously want to retry, but then how to avoid busy looping?
		// -> maybe do the retry but also then throw exception to indicate the failure
		// this means that before throw the buffers have to be swapped back so that non-error previous read is not lost
	if (TUN_TAP_status == 1) {
		if (received_sync > 0) {

			DWORD bytes_read = received_sync;
			memcpy(buf, recv_buf, bytes_read);
			//std::swap(buf, recv_buf);
			//if (buf.size() < recv_buf.size())
			//	buf.resize(recv_buf.size());
			tuntap_do_read();
			return bytes_read;
		}
		else if (HasOverlappedIoCompleted(&recv_overlapped)) {
			DWORD bytes_read;
			if (GetOverlappedResult(fd, &recv_overlapped, &bytes_read, FALSE) == FALSE) {
				//#warning fixme GetLastError, throw exception
					// GetLastError should not be ERROR_IO_INCOMPLETE because otherwise HasOverlappedIoCompleted should have been false
			}
			memcpy(buf, recv_buf, bytes_read);
			//std::swap(buf, recv_buf);
			//if (buf.size() < recv_buf.size())
			//	buf.resize(recv_buf.size());
			tuntap_do_read();
			return bytes_read;
		}
	}
	// else async read is still in progress, no data to return yet
	return 0;
}

//bool tuntap_send_packet(dbuf &buf, size_t len)

int tuntap_send_packet(unsigned char* buf, size_t len)
{
	if (TUN_TAP_status == 1) {
		if (sent_sync || HasOverlappedIoCompleted(&send_overlapped)) {
			//if (1) {
				//std::swap(buf, send_buf);
			memcpy(send_buf, buf, len);
			//if (buf.size() < send_buf.size())
			//	buf.resize(send_buf.size());
			tuntap_do_write(len);
			return 1;
		}
	}
	// else previous async send has not completed
	return 0;
}

#endif
